;##########################################################################
; Listview Template
;##########################################################################
InitListView			PROTO :DWORD ; Place in WM_INITDIALOG event
InitImageList			PROTO :DWORD ; Place in WM_INITDIALOG event if using imagelists
SizeListView			PROTO :DWORD, :DWORD ; Place in WM_SIZE event
ListViewAltRowColour	PROTO :DWORD, :DWORD ; Place in WM_NOTIFY event ; !NOTWORKING!
InitLVRightClickMenu	PROTO :DWORD ; Place in WM_INITDIALOG event
LVRCMenuPopupSelection	PROTO :DWORD, :DWORD ; Place in WM_COMMAND event
ListViewSelectAll		PROTO :DWORD
ListViewGridlines		PROTO :DWORD ; Place wherever
ListViewCheckboxes		PROTO :DWORD ; Place wherever 
ListViewClearAll		PROTO ; Place wherever
ListViewInsertItem		PROTO :DWORD, :DWORD
ListViewInsertSubItem	PROTO :DWORD, :DWORD
ListViewSetCheckBox		PROTO :DWORD, :DWORD
ListViewUnSetCheckBox	PROTO :DWORD, :DWORD
ListViewSetSelection	PROTO :DWORD, :DWORD
ListViewGetSelection	PROTO :DWORD	
ListViewGetItemText		PROTO :DWORD, :DWORD, :DWORD
ListViewSetItemText		PROTO :DWORD, :DWORD, :DWORD
ListViewSetItemIcon		PROTO :DWORD, :DWORD, :DWORD


Include 	\masm32\include\gdi32.inc		; For Font
Include 	\masm32\include\Comctl32.inc	; For listview control
Include		\masm32\include\ole32.inc		; For COM/OLE - listview image

includelib	\masm32\lib\gdi32.lib			; For Font
includelib	\masm32\lib\Comctl32.lib		; For listview control
includelib	\masm32\lib\ole32.lib			; For COM/OLE - listview image


;**************************************************************************
; MOD Macro
;**************************************************************************
_mod MACRO val1:REQ, val2:REQ
push ecx
mov  eax,val1
mov  ecx,val2
xor  edx,edx
div  ecx  
pop ecx
exitm <edx>
endm

;USE_LISTVIEW_WITH_TOOLBAR 		equ 1 ; Uncomment to use with toolbar.asm or comment out
USE_LISTVIEW_WITH_IMAGELIST 	equ 2 ; Uncomment to use with imagelist or comment out

;**************************************************************************
.CONST

; Listview Right Click Popup Menu 
IDM_LVRC_NEWPROFILE	equ 8707 ; Popup Menu - Option 1
IDM_LVRC_EDITPROFILE	equ 8700 ; Popup Menu - Option 1
IDM_LVRC_COPYPROFILE	equ 8706
IDM_LVRC_DELETEPROFILE	equ 8701 ; Popup Menu - Option 2
IDM_LVRC_SELECTPROFILE		equ 8702 ; Popup Menu - Option 3
IDM_LVRC_SEP		equ 8703 ; Popup Menu - Seperator
IDM_LVRC_SELECTALL 	equ 8704 ; Popup Menu - Option 4
IDM_LVRC_EDITCFG 	equ 8705 ; Popup Menu - Option 5

; Listview RightClick Menu Bitmap IDs
LVRC_EXTRACT		equ	3501
LVRC_VIEW			equ	3502
LVRC_INFO			equ	3503

; Colour Constants
COLOUR_WHITE		EQU 00FFFFFFh
COLOUR_BLACK		EQU 00000000h
COLOUR_RED			EQU 000000FFh
COLOUR_LIGHT_BLUE	EQU 00FFF3F2h
COLOUR_DARK_BLUE	EQU 00A00000h
COLOUR_LIGHT_GRAY	EQU 00F9F9F9h
COLOUR_LIGHT_YELLOW	EQU 0091FFFFh
COLOUR_TEAL			EQU 00808000h
COLOUR_ORANGE		EQU 00A00000h



; Listview Constants - Here for information purposes - Included with Windows.inc

; Listview Background Image Constants
;LVBKIF_SOURCE_NONE      	EQU 00000000h
;LVBKIF_SOURCE_HBITMAP   	EQU 00000001h
;LVBKIF_SOURCE_URL       	EQU 00000002h
;LVBKIF_SOURCE_MASK      	EQU 00000003h
;LVBKIF_STYLE_NORMAL     	EQU 00000000h
;LVBKIF_STYLE_TILE       	EQU 00000010h
;LVBKIF_STYLE_MASK       	EQU 00000010h

; Listview Styles
;LVS_ICON					EQU 0000h
;LVS_REPORT      			EQU 0001h
;LVS_SMALLICON   			EQU 0002h
;LVS_LIST        			EQU 0003h
;LVS_TYPEMASK    			EQU 0003h
;LVS_SINGLESEL   			EQU 0004h
;LVS_SHOWSELALWAYS			EQU 0008h
;LVS_SORTASCENDING			EQU 0010h
;LVS_SORTDESCENDING			EQU 0020h
;LVS_SHAREIMAGELISTS		EQU 0040h
;LVS_NOLABELWRAP 			EQU 0080h
;LVS_AUTOARRANGE 			EQU 0100h
;LVS_EDITLABELS  			EQU 0200h
;LVS_NOSCROLL    			EQU 2000h
;LVS_TYPESTYLEMASK			EQU 0fc00h
;LVS_ALIGNTOP    			EQU 0000h
;LVS_ALIGNLEFT   			EQU 0800h
;LVS_ALIGNMASK   			EQU 0c00h
;LVS_OWNERDRAWFIXED			EQU 0400h
;LVS_NOCOLUMNHEADER			EQU 4000h
;LVS_NOSORTHEADER			EQU 8000h

; Listview Extended Styles
;LVS_EX_GRIDLINES			EQU 00000001h
;LVS_EX_SUBITEMIMAGES		EQU 00000002h
;LVS_EX_CHECKBOXES			EQU 00000004h
;LVS_EX_TRACKSELECT			EQU 00000008h
;LVS_EX_HEADERDRAGDROP		EQU 00000010h
;LVS_EX_FULLROWSELECT		EQU 00000020h
;LVS_EX_ONECLICKACTIVATE	EQU 00000040h
;LVS_EX_TWOCLICKACTIVATE	EQU 00000080h
;LVS_EX_FLATSB				EQU 00000100h
;LVS_EX_REGIONAL			EQU 00000200h
;LVS_EX_INFOTIP				EQU 00000400h
;LVS_EX_UNDERLINEHOT		EQU 00000800h
;LVS_EX_UNDERLINECOLD		EQU 00001000h
;LVS_EX_MULTIWORKAREAS		EQU 00002000h
;LVS_EX_LABELTIP			EQU 00004000h

;LVCF_IMAGE					EQU 0010h
;LVCF_ORDER					EQU 0020h
;LVCFMT_IMAGE				EQU 0800h
;LVCFMT_BITMAP_ON_RIGHT		EQU 1000h
;LVCFMT_COL_HAS_IMAGES		EQU 8000h

;LVM_GETHEADER				EQU LVM_FIRST + 31
;LVM_SETEXTENDEDLISTVIEWSTYLE	EQU LVM_FIRST + 54
;LVM_GETEXTENDEDLISTVIEWSTYLE	EQU LVM_FIRST + 55

; Listview Column Format
;LVCF_FMT        			EQU 0001h
;LVCF_WIDTH      			EQU 0002h
;LVCF_TEXT       			EQU 0004h
;LVCF_SUBITEM    			EQU 0008h
;LVCFMT_LEFT     			EQU 0000h
;LVCFMT_RIGHT    			EQU 0001h
;LVCFMT_CENTER   			EQU 0002h
;LVCFMT_JUSTIFYMASK			EQU 0003h

; Listview Events Messages
;LVM_GETCOLUMN   			EQU LVM_FIRST + 25
;LVM_GETCOLUMNW   			EQU LVM_FIRST + 95
;LVM_SETCOLUMN   			EQU LVM_FIRST + 26
;LVM_SETCOLUMNW   			EQU LVM_FIRST + 96
;LVM_INSERTCOLUMN			EQU LVM_FIRST + 27
;LVM_INSERTCOLUMNW			EQU LVM_FIRST + 97
;LVM_DELETECOLUMN			EQU LVM_FIRST + 28
;LVM_GETCOLUMNWIDTH			EQU LVM_FIRST + 29
;LVM_SETCOLUMNWIDTH   		EQU LVM_FIRST + 30
;LVM_CREATEDRAGIMAGE		EQU LVM_FIRST + 33
;LVM_GETVIEWRECT   			EQU LVM_FIRST + 34
;LVM_GETTEXTCOLOR			EQU LVM_FIRST + 35
;LVM_SETTEXTCOLOR			EQU LVM_FIRST + 36
;LVM_GETTEXTBKCOLOR			EQU LVM_FIRST + 37
;LVM_SETTEXTBKCOLOR			EQU LVM_FIRST + 38
;LVM_GETTOPINDEX   			EQU LVM_FIRST + 39
;LVM_GETCOUNTPERPAGE		EQU LVM_FIRST + 40
;LVM_GETORIGIN   			EQU LVM_FIRST + 41
;LVM_UPDATE   				EQU LVM_FIRST + 42
;LVM_SETITEMSTATE			EQU LVM_FIRST + 43
;LVM_GETITEMSTATE			EQU LVM_FIRST + 44
;LVM_GETITEMTEXT   			EQU LVM_FIRST + 45
;LVM_GETITEMTEXTW			EQU LVM_FIRST + 115
;LVM_SETITEMTEXT   			EQU LVM_FIRST + 46
;LVM_SETITEMTEXTW			EQU LVM_FIRST + 116
;LVM_SETITEMCOUNT			EQU LVM_FIRST + 47
;LVM_SORTITEMS   			EQU LVM_FIRST + 48
;LVM_SETITEMPOSITION32		EQU LVM_FIRST + 49
;LVM_GETSELECTEDCOUNT		EQU LVM_FIRST + 50
;LVM_GETITEMSPACING			EQU LVM_FIRST + 51
;LVM_GETISEARCHSTRING		EQU LVM_FIRST + 52
;LVM_GETISEARCHSTRINGW		EQU LVM_FIRST + 117

; Listview Notifications
;LVN_ITEMCHANGING			EQU LVN_FIRST-0
;LVN_ITEMCHANGED   			EQU LVN_FIRST-1
;LVN_INSERTITEM   			EQU LVN_FIRST-2
;LVN_DELETEITEM   			EQU LVN_FIRST-3
;LVN_DELETEALLITEMS   		EQU LVN_FIRST-4
;LVN_BEGINLABELEDIT   		EQU LVN_FIRST-5
;LVN_BEGINLABELEDITW   		EQU LVN_FIRST-75
;LVN_ENDLABELEDIT   		EQU LVN_FIRST-6
;LVN_ENDLABELEDITW   		EQU LVN_FIRST-76
;LVN_COLUMNCLICK   			EQU LVN_FIRST-8
;LVN_BEGINDRAG   			EQU LVN_FIRST-9
;LVN_BEGINRDRAG   			EQU LVN_FIRST-11
;LVN_GETDISPINFO   			EQU LVN_FIRST-50
;LVN_GETDISPINFOW   		EQU LVN_FIRST-77
;LVN_SETDISPINFO   			EQU LVN_FIRST-51
;LVN_SETDISPINFOW			EQU LVN_FIRST-78
;
;LVSCW_AUTOSIZE				EQU -1
 
;**************************************************************************


.DATA

LVItemText			db MAX_PATH dup (0) ; Buffer to hold text to display when used with LVItem
LVItem				LV_ITEM <LVIF_TEXT,1,0,LVIS_FOCUSED,0,LVItemText,MAX_PATH,0,0>
LVFontMS			db "MS Sans Serif",0
LVFontLF			LOGFONT <>

hLVRCMenuPopup		dd 0		; Listview Menu Popup Handle
LVRCMenuPoint		POINT <> 	; Listview Menu Popup point tracker

LVRCSelectAll		db "Select All",09h,"Ctrl+A",0

.DATA?
hListview			dd ?	 	; Listview handle
hImagelist			dd ?		; ImageList handle


.CODE
;**************************************************************************
; Initialize the Listview Control - Call from WM_INITDIALOG event
;**************************************************************************
InitListView	PROC hWin:DWORD
	LOCAL LVImage:LVBKIMAGE ; Listview Background Image Structure
	LOCAL LVColumn:LV_COLUMN; Lisview Column Structure
	LOCAL hLVHeader:DWORD	; Listview Header Handle
	LOCAL hLVFont:DWORD 	; Listview Font Handle
			
	; Get handle of lisview and save it
	Invoke GetDlgItem, hWin, IDC_LISTVIEW
	mov hListview, eax

	;****************************
	; Listview Image
	;****************************

	; Load listview Image
;	Invoke CoInitialize, NULL ; Needed to set listview image
;	mov LVImage.ulFlags, LVBKIF_SOURCE_URL
;	mov LVImage.pszImage, CTEXT("M:\Radasm\Masm\Projects\BIFUtil\Listview_grey.bmp")
;	mov LVImage.cchImageMax, 10270 ; Listview image size
;	mov LVImage.xOffsetPercent, 100 ; Listview image x position
;	mov LVImage.yOffsetPercent, 100 ; Listview image y position
;	INVOKE SendMessage, hListview, LVM_SETBKIMAGE, 0, addr LVImage ; Set image
; 	Invoke SendMessage, hListview, LVM_SETTEXTBKCOLOR, 0, CLR_NONE ; Transparent rows

	;****************************
	; Listview Style - Header
	;****************************

	; These 5 lines create a FLAT columnheader
	Invoke SendMessage, hListview, LVM_GETHEADER, 0, 0 ; Get handle to listview header 
	mov hLVHeader,eax   ; Save listview header handle 
	Invoke GetWindowLong, hLVHeader, GWL_STYLE ; get current window styles 
	xor eax, HDS_BUTTONS 
	Invoke SetWindowLong, hLVHeader, GWL_STYLE, eax ; Set the new listview header style

	;****************************
	; Listview Style - Extended
	;****************************

	; Setup extended styles like gridlines
	mov eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES
	; or setup extended styles with hot tracking, full row selections etc
	;mov eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES or LVS_EX_TRACKSELECT or LVS_EX_ONECLICKACTIVATE
	Invoke SendMessage, hListview, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax ; Do It

	;****************************
	; Listview Text Colour
	;****************************

	; Set text color, listview background colour and text background color
	;Invoke SendMessage, hListview, LVM_SETTEXTCOLOR, 0, 00000000h
	;invoke SendMessage, hListview, LVM_SETBKCOLOR, 0, 00FFFFFFh
	;Invoke SendMessage, hListview, LVM_SETTEXTBKCOLOR, 0,00A6F7F0h

	;****************************
	; Listview Font
	;****************************

	; Change listview font
	INVOKE lstrcpy, addr LVFontLF.lfFaceName, addr LVFontMS
	mov LVFontLF.lfHeight, 15
	mov LVFontLF.lfWeight, 500
	Invoke CreateFontIndirect, addr LVFontLF
	mov hLVFont, eax ; Listview font
	Invoke SendMessage, hListview, WM_SETFONT, hLVFont, 1

	;****************************
	; Listview Columns
	;****************************
	
	; First Column
	mov LVColumn.imask, LVCF_TEXT or LVCF_WIDTH or LVCFMT_COL_HAS_IMAGES
	mov LVColumn.pszText, CTEXT("Profile Name")
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.lx, 152
	Invoke SendMessage, hListview, LVM_INSERTCOLUMN, 0, addr LVColumn  

	; Second Column
	;or LVColumn.imask, LVCF_FMT
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.pszText, CTEXT("Profile Description")
	mov LVColumn.lx, 268
	Invoke SendMessage, hListview, LVM_INSERTCOLUMN, 1, addr LVColumn 
	
;	; Third Column	
;	or LVColumn.imask, LVCF_FMT
;	mov LVColumn.fmt, LVCFMT_RIGHT
;	mov LVColumn.pszText, CTEXT("Resource Offset")
;	mov LVColumn.lx, 120
;	Invoke SendMessage, hListview, LVM_INSERTCOLUMN, 2, addr LVColumn 
;	
;	; Fourth Column	
;	or LVColumn.imask, LVCF_FMT
;	mov LVColumn.fmt, LVCFMT_RIGHT
;	mov LVColumn.pszText, CTEXT("Resource Size (Bytes)")
;	mov LVColumn.lx, 135
;	Invoke SendMessage, hListview, LVM_INSERTCOLUMN, 3, addr LVColumn   
;	
;	; Fifth Column	
;	or LVColumn.imask, LVCF_FMT
;	mov LVColumn.fmt, LVCFMT_RIGHT
;	mov LVColumn.pszText, CTEXT("Resource Type (Hex)")
;	mov LVColumn.lx, 120
;	Invoke SendMessage, hListview, LVM_INSERTCOLUMN, 4, addr LVColumn 	

	; Sixth Column	
;	or LVColumn.imask, LVCF_FMT
;	mov LVColumn.fmt, LVCFMT_RIGHT
;	mov LVColumn.pszText, CTEXT("Column6 Name")
;	mov LVColumn.lx, 100
;	Invoke SendMessage, hListview, LVM_INSERTCOLUMN, 5, addr LVColumn 	 		
	
	IFDEF USE_LISTVIEW_WITH_IMAGELIST
		Invoke InitImageList,hWin
	ENDIF
	
	ret

InitListView	ENDP


;**************************************************************************
; Initialize the ImageList Control - Call from WM_INITDIALOG event
;**************************************************************************
InitImageList	PROC hWin:DWORD
	LOCAL hILIcon:DWORD
	
	invoke ImageList_Create,16,16,ILC_COLOR32,1,20	
	.IF eax != NULL
		mov hImagelist, eax
	.else
		PrintText 'Failed to create imagelist'
	.endif
	invoke  SendMessage,hListview,LVM_SETIMAGELIST,LVSIL_SMALL,hImagelist
	invoke  SendMessage,hListview,LVM_SETIMAGELIST,LVSIL_SMALL,hImagelist
	
	; Load icons and add to list
	Invoke LoadIcon, hInstance, ICO_CSS
	mov hILIcon, eax
	.IF eax == NULL
		PrintText 'Icon Not Loaded'
	.endif
    invoke ImageList_AddIcon,hImagelist,eax
    .IF eax == -1
    	PrintText 'Icon Not Added'
    .endif

;	Invoke LoadIcon, hInstance, ICO_HLD
;	mov hILIcon, eax
    invoke ImageList_Add,hImagelist,hILIcon,NULL

;	Invoke LoadIcon, hInstance, ICO_DOD
;	mov hILIcon, eax
    invoke ImageList_Add,hImagelist,hILIcon,NULL

;	Invoke LoadIcon, hInstance, ICO_TF2
;	mov hILIcon, eax
    invoke ImageList_Add,hImagelist,hILIcon,NULL
	
	
	ret

InitImageList endp


;**************************************************************************	
; Size Listview to window size minus any toolbars - Call from WM_SIZE event
;**************************************************************************	
SizeListView	PROC	hWin:DWORD, lParam:DWORD
	LOCAL rect:RECT
	LOCAL tbHeight:DWORD 

	IFDEF USE_LISTVIEW_WITH_TOOLBAR
		mov eax, ToolBarHeight
		.if ToolBarTextFlag
			add eax, 22
		.else
			add eax, 8
		.endif
		add eax,5
		mov tbHeight, eax
		
		Invoke GetClientRect, hListview, addr rect ; get current size of listview
		mov ebx,lParam
		and ebx,0FFFFh ; get loword of lParam in ebx
		sub ebx, 2 ; take 2 for borders either side of main window/dialog
		mov eax,lParam
		shr eax,16 ; get hiword of lParam in eax
		;sub eax, 95 ; subtract value from height of toolbar band
		
		sub eax, tbHeight
		sub eax, 20 ; header height
	
		; resize listview based on main window, minus adjustments for toolbars etc
		; Left, Top, Width, Height, Redraw
	
	
		Invoke MoveWindow, hListview, 2, tbHeight, ebx, eax, TRUE
	ENDIF

	ret
SizeListView	ENDP


;**************************************************************************	
; Initialize the right click popup menu for the listview
;**************************************************************************	
InitLVRightClickMenu	PROC	hWin:DWORD
	LOCAL hBmp:DWORD
	invoke CreatePopupMenu	; Create Listview Right Click Popup Menu
	mov hLVRCMenuPopup, eax ; Save Listview Right Click Menu Popup Handle

	invoke AppendMenu, hLVRCMenuPopup, MF_STRING, IDM_LVRC_NEWPROFILE, CTEXT("New Profile...")
	invoke AppendMenu, hLVRCMenuPopup, MF_STRING, IDM_LVRC_EDITPROFILE, CTEXT("Edit Profile...")
	invoke AppendMenu, hLVRCMenuPopup, MF_STRING, IDM_LVRC_COPYPROFILE, CTEXT("Copy Profile...")
	invoke AppendMenu, hLVRCMenuPopup, MF_SEPARATOR, 0, 0
	invoke AppendMenu, hLVRCMenuPopup, MF_STRING, IDM_LVRC_DELETEPROFILE, CTEXT("Delete Profile")
;	invoke AppendMenu, hLVRCMenuPopup, MF_STRING, IDM_LVRC_SELECTPROFILE, CTEXT("Select Profile")
;	invoke AppendMenu, hLVRCMenuPopup, MF_SEPARATOR, 0, 0
;	invoke AppendMenu, hLVRCMenuPopup, MF_STRING, IDM_LVRC_SELECTALL, Addr LVRCSelectAll
	invoke AppendMenu, hLVRCMenuPopup, MF_SEPARATOR, 0, 0
	invoke AppendMenu, hLVRCMenuPopup, MF_STRING, IDM_LVRC_EDITCFG, CTEXT("Open Cfg Files...")

	; Load bitmaps
;	Invoke LoadBitmap, hInstance, LVRC_EXTRACT
;	mov hBmp, eax
;	Invoke SetMenuItemBitmaps, hLVRCMenuPopup, IDM_LVRC_EXTRACT, MF_BYCOMMAND+MF_BITMAP, hBmp, hBmp

;	Invoke LoadBitmap, hInstance, LVRC_VIEW
;	mov hBmp, eax
;	Invoke SetMenuItemBitmaps, hLVRCMenuPopup, IDM_LVRC_VIEW, MF_BYCOMMAND+MF_BITMAP, hBmp, hBmp

;	Invoke LoadBitmap, hInstance, LVRC_INFO
;	mov hBmp, eax
;	Invoke SetMenuItemBitmaps, hLVRCMenuPopup, IDM_LVRC_FILEINFO, MF_BYCOMMAND+MF_BITMAP, hBmp, hBmp

	
	ret
InitLVRightClickMenu	ENDP


;**************************************************************************
; Selection of a menu item from tray popup menu - Call from WM_COMMAND
;**************************************************************************
LVRCMenuPopupSelection	PROC	hWin:DWORD, wParam:DWORD
	mov eax,wParam

	.IF eax==IDM_LVRC_EDITPROFILE
		;Invoke MessageBox,NULL, CTEXT("Open With") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST
		
		Invoke ListViewGetSelection,hWin
		mov ListItemIndex, eax
		.IF eax==-1
			mov eax, CurrentProfileNo
			mov ListItemIndex, eax
		.endif						
		invoke DialogBoxParam,hInstance, IDD_ProfileAddEdit, hWin, OFFSET SteamProfileAddEditProc, ListItemIndex		
		
	.ELSEIF eax==IDM_LVRC_NEWPROFILE
		invoke DialogBoxParam,hInstance, IDD_ProfileAddEdit, hWin, OFFSET SteamProfileAddEditProc, -1
			
	.ELSEIF eax==IDM_LVRC_DELETEPROFILE
		;Invoke MessageBox,NULL, CTEXT("Extract") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST
	
		Invoke ListViewGetSelection,hWin
		mov ListItemIndex, eax
		.IF eax==-1
			mov eax, CurrentProfileNo
			mov ListItemIndex, eax
		.endif						
		Invoke DelProfile, hWin, ListItemIndex
	
	.ELSEIF eax==IDM_LVRC_COPYPROFILE
		Invoke ListViewGetSelection,hWin
		mov ListItemIndex, eax	
		.IF eax==-1
			mov eax, CurrentProfileNo
			mov ListItemIndex, eax
		.endif						
		invoke DialogBoxParam,hInstance, IDD_ProfileCopy, hWin, OFFSET SteamProfileCopyProc, ListItemIndex		
		
		;Invoke ListViewGridlines,hWin
	;.ELSEIF eax==IDM_LVRC_SELECTPROFILE
		;Invoke MessageBox,NULL, CTEXT("View") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST
	.ELSEIF eax==IDM_LVRC_SELECTALL
		;Invoke MessageBox,NULL, CTEXT("Select All") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST
		;Invoke ListViewSelectAll, hWin
	.ELSEIF eax==IDM_LVRC_EDITCFG
	;	Invoke MessageBox,NULL, CTEXT("Edit Cfg") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST
		Invoke ListViewGetSelection,hWin
		mov ListItemIndex, eax
		.IF eax==-1
			mov eax, CurrentProfileNo
			mov ListItemIndex, eax
		.endif	
		Invoke EditProfileCfgs,hWin, ListItemIndex		
		
	.ELSE
		; No menu selction occured so continue back up to WM_COMMAND
	.ENDIF

	ret
LVRCMenuPopupSelection	ENDP


;**************************************************************************	
; Select all items in listview
;**************************************************************************	
ListViewSelectAll		PROC	hWin:DWORD
	LOCAL LVSAItem:LV_ITEM
	
	; Deselect everything first
	mov LVSAItem.stateMask,LVIS_SELECTED
	mov LVSAItem.state,NULL
	invoke SendMessage,hListview,LVM_SETITEMSTATE,-1,ADDR LVSAItem
	
	; Select everything
	mov LVSAItem.stateMask,LVIS_SELECTED
	mov LVSAItem.state,LVIS_SELECTED
	invoke SendMessage,hListview,LVM_SETITEMSTATE,-1,ADDR LVSAItem
	
	ret

ListViewSelectAll 		ENDP


;**************************************************************************	
; Toggles Listview Gridlines On/Off
;**************************************************************************	
ListViewGridlines		PROC	hWin:DWORD
	
	; Get current extended styles like gridlines
	Invoke SendMessage, hListview, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0
	mov edx, LVS_EX_GRIDLINES ; gridlines
	xor eax, edx ; Toggle gridlines on/off
	Invoke SendMessage, hListview, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax ; Do It
	
	ret

ListViewGridlines 		ENDP


;**************************************************************************	
; Toggles Checkbox Column  On/Off
;**************************************************************************
ListViewCheckboxes	PROC	hWin:DWORD

	; Get current extended styles like gridlines
	Invoke SendMessage, hListview, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0	
	mov edx, LVS_EX_CHECKBOXES ; Checkboxes
	xor eax, edx ; Toggle checkboxes on/off
	Invoke SendMessage, hListview, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax ; Do It	
	ret

ListViewCheckboxes endp	


;**************************************************************************
; Inserts an item into the listbox. LVItemText should be filled before this
; is called, as this is the buffer that is used.
;**************************************************************************
ListViewInsertItem	PROC	hWin:DWORD, nItem:DWORD
	
	mov eax, nItem
	mov LVItem.iItem, eax	
	mov LVItem.iSubItem,0
	invoke SendMessage, hListview, LVM_INSERTITEM, 0, Addr LVItem
	mov LVItem.iItem, eax
	
	ret

ListViewInsertItem endp


;**************************************************************************
; Inserts an Sub-item into the listbox. LVItemText should be filled before this
; is called, as this is the buffer that is used. nSubItem is the index.
;**************************************************************************
ListViewInsertSubItem	PROC hWin:DWORD, nSubItem:DWORD
;	mov eax, nItem
;	mov LVItem.iItem, eax
	mov eax, nSubItem
	mov LVItem.iSubItem, eax
	invoke SendMessage, hListview, LVM_SETITEM, 0, addr LVItem
		
	ret

ListViewInsertSubItem endp


;**************************************************************************
; Gets the text of the specified index. Stored in LVItemText on return
;**************************************************************************
ListViewGetItemText		PROC hWin:DWORD, nItem:DWORD, nSubItem:DWORD
	mov eax, nSubItem
	mov LVItem.iSubItem, eax
	invoke SendMessage, hListview, LVM_GETITEMTEXT, nItem, Addr LVItem
	
	ret

ListViewGetItemText endp


;**************************************************************************
; Sets the icon of the specified index. 
;**************************************************************************
ListViewSetItemIcon		PROC hWin:DWORD, nItem:DWORD, nIcon:DWORD
	mov eax, nIcon
	mov LVItem.iImage, eax
	invoke SendMessage, hListview, LVM_SETITEM, nItem, Addr LVItem
	
	ret

ListViewSetItemIcon endp


;**************************************************************************
; Sets the text of the specified index. Store data in LVItemText for this
;**************************************************************************
ListViewSetItemText		PROC hWin:DWORD, nItem:DWORD, nSubItem:DWORD
	mov eax, nSubItem
	mov LVItem.iSubItem, eax
	invoke SendMessage, hListview, LVM_SETITEMTEXT, nItem, Addr LVItem
	
	ret

ListViewSetItemText endp


;**************************************************************************
; Set an Listitem checkbox. nItemIndex is the 0 based index to specify.
;**************************************************************************
ListViewSetCheckBox	PROC hWin:DWORD, nItemIndex:DWORD

	
	mov LVItem.iItem, 2
	mov LVItem.iSubItem, 0
	mov LVItem.imask, LVIF_STATE
	mov LVItem.stateMask, LVIS_STATEIMAGEMASK
	xor eax, eax
	mov eax,2                     ; set check
	shl eax,12	
	mov LVItem.state, eax
	Invoke SendMessage, hListview, LVM_SETITEMSTATE, nItemIndex, addr LVItem
	
	ret

ListViewSetCheckBox endp


;**************************************************************************
; Set an Listitem checkbox. nItemIndex is the 0 based index to specify.
;**************************************************************************
ListViewUnSetCheckBox	PROC hWin:DWORD, nItemIndex:DWORD

	
	mov LVItem.iItem, 2
	mov LVItem.iSubItem, 0
	mov LVItem.imask, LVIF_STATE
	mov LVItem.stateMask, LVIS_STATEIMAGEMASK
	xor eax, eax
	mov eax,1                     ; unset check
	shl eax,12	
	mov LVItem.state, eax
	Invoke SendMessage, hListview, LVM_SETITEMSTATE, nItemIndex, addr LVItem
	
	ret

ListViewUnSetCheckBox endp


;**************************************************************************	
; Set the currently selected item to a specified index
;**************************************************************************	
ListViewSetSelection	PROC hWin:DWORD, nItemIndex:DWORD
	
	; Release current focus
	mov LVItem.state, 0
	mov LVItem.stateMask, LVIS_SELECTED + LVIS_FOCUSED
	invoke SendMessage, hListview, LVM_SETITEMSTATE, -1, addr LVItem

	; Set current focus
	mov LVItem.state, LVIS_SELECTED + LVIS_FOCUSED
	mov LVItem.stateMask, LVIS_SELECTED + LVIS_FOCUSED
	invoke SendMessage, hListview, LVM_SETITEMSTATE, nItemIndex, addr LVItem
	
	ret

ListViewSetSelection endp


;**************************************************************************	
; Get Index of Currently Selected Item in Listview
;**************************************************************************	
ListViewGetSelection	PROC hWin:DWORD
	
	Invoke SendMessage, hListview,LVM_GETNEXTITEM, -1, LVNI_FOCUSED
	ret

ListViewGetSelection endp


;**************************************************************************	
; Display alternate row colours in listview - Place in WM_NOTIFY event
; 00F9F9F9h Light Grey | 00FFF3F2h Light Blue | 00FFF0E6h; 00FFE4D0h ; 00A6F7F0h 
; 
; Not Working!
;**************************************************************************	
ListViewAltRowColour	PROC	hWin:DWORD, lParam:DWORD
	mov edi,lParam
	assume edi:ptr NMHDR
	mov eax,[edi].hwndFrom

	.if eax==hListview
		.if [edi].code==NM_CUSTOMDRAW
			assume edi:ptr NMLVCUSTOMDRAW
			mov eax,[edi+NMLVCUSTOMDRAW.nmcd.dwDrawStage]
			.if eax == CDDS_SUBITEM || CDDS_ITEMPREPAINT
            	; Alternate Row Colour
				mov esi,[edi+NMLVCUSTOMDRAW.nmcd.dwItemSpec]
				; Calc mod of item to see if the background should be applied
				.if  _mod(esi,2) == 0 
					mov [edi].clrTextBk, COLOUR_LIGHT_BLUE ; Background = light blue
					mov [edi].clrText, COLOUR_BLACK   ; text color = black
				.else
					mov [edi].clrTextBk, COLOUR_WHITE  ; Background = white
					mov [edi].clrText, COLOUR_BLACK         ; text color = black
				.endif
			.endif
			return 32
		.endif
		return 0
	.endif

	return 0

ListViewAltRowColour	ENDP	


;**************************************************************************	
; Delete all data from listview
;**************************************************************************	
ListViewClearAll	PROC
	
	; Clear all list items
	Invoke SendMessage, hListview, LVM_DELETEALLITEMS, 0, 0
	
	ret

ListViewClearAll endp

	

;**************************************************************************
; *-----------------------------------------------------------------------*
;
; LISTVIEW - SETUP REQUIREMENTS
;
; *-----------------------------------------------------------------------*
;**************************************************************************

; Add the following to WM_COMMAND to enable processing 

;.ELSEIF eax==WM_COMMAND
;	mov eax,wParam
;
;	.ELSE
;		; Check to see if a Listview Right Click Menu item has been selected
;		Invoke LVRCMenuPopupSelection, hWin, wParam
;	.ENDIF

; *-----------------------------------------------------------------------*
; Please add the following code to WM_NOTIFY event for the right click menu
; *-----------------------------------------------------------------------*

;.ELSEIF eax==WM_NOTIFY
;	mov edi,lParam
;	assume edi:ptr NMHDR
;	mov eax,[edi].hwndFrom
;	.if eax==hListview
;		mov eax, [edi].code
;		.if eax == NM_RCLICK ; right click popup
;			assume edi:ptr NMHDR
;			Invoke SendMessage, hListview , LVM_GETNEXTITEM, -1, LVNI_FOCUSED+LVNI_SELECTED
;			.if eax == -1
;				ret ; no need to show menu as nothing selected
;			.endif

;			Invoke GetCursorPos, addr LVRCMenuPoint
;			; Focus Main Window - ; Fix for shortcut menu not popping up right
;			Invoke SetForegroundWindow, hWin 
;			Invoke TrackPopupMenu, hLVRCMenuPopup, TPM_LEFTALIGN, LVRCMenuPoint.x, LVRCMenuPoint.y, NULL, hWin, NULL
;			Invoke PostMessage, hWin, WM_NULL, 0, 0 ; Fix for shortcut menu not popping up right


; *-----------------------------------------------------------------------*
; Please add the following code to WM_NOTIFY event for the other clicks
; *-----------------------------------------------------------------------*

;		.elseif eax == NM_DBLCLK ; Listview Double Click
;			invoke MessageBox,NULL, CTEXT("DBLCLICK") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST

;		.elseif eax == LVN_KEYDOWN ; Key has been pressed
;			assume edi:ptr LV_KEYDOWN
;			xor eax, eax
;			mov ax, [edi+LV_KEYDOWN.wVKey]	
;			;and eax,(0FFH or VK_CONTROL) ; retain only character and modifier flag
;			invoke MessageBox,NULL, CTEXT("KEYPRESS") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST
;			assume edi:ptr NMHDR 
				
;		.elseif eax == LVN_COLUMNCLICK ; Column header was clicker
;			invoke MessageBox,NULL, CTEXT("COLUMNCLICK") ,ADDR AppName,MB_OK+MB_TASKMODAL+MB_TOPMOST
;			assume edi:ptr NMHDR


; *-----------------------------------------------------------------------*
; Please add the following code to WM_NOTIFY event for alt row colour
; *-----------------------------------------------------------------------*
;		.elseif [edi].code==NM_CUSTOMDRAW
;			assume edi:ptr NMLVCUSTOMDRAW
;	             
;			mov eax,[edi+NMLVCUSTOMDRAW.nmcd.dwDrawStage]
;			.if eax == CDDS_SUBITEM || CDDS_ITEMPREPAINT
;				; Specific column colour
;				;.if  [edi].iSubItem == 2
;				;	mov [edi].clrTextBk,0080FFFFh ;Background text = yellow
;				;	mov [edi].clrText,000000FFh   ; text color = red
;				;.else
;				;	mov [edi].clrTextBk,0FFFFFFh  ;Background text = white
;				;	mov [edi].clrText,00h         ; text color = black
;				;.endif
;			
;				; Alternate Row Colour
;				mov esi,[edi+NMLVCUSTOMDRAW.nmcd.dwItemSpec]
;				.if  _mod(esi,2) == 0 ; Calc mod of item to see if the background should be applied
;					mov [edi].clrTextBk,00FFF3F2h; 00F9F9F9h ; Light Grey | 00FFF3F2h Light Blue | 00FFF0E6h; 00FFE4D0h ; 00A6F7F0h ;Background text = light yellow
;					mov [edi].clrText,00000000h   ; text color = red
;				.else
;					mov [edi].clrTextBk,0FFFFFFh  ;Background text = white
;					mov [edi].clrText,00h         ; text color = black
;				.endif
;			.endif
;			return 32
;		.endif
;		return 0